"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var cellShape = _propTypes.default.shape({
  /**
   * Content that will be rendered within the Cell.
   */
  content: _propTypes.default.node,
  /**
   * Boolean indicating if cell contents are masked.
   */
  isMasked: _propTypes.default.bool,
  /**
   * Provides a custom string for masked cells to be read by screen readers. This value is only applied if the cell is masked.
   */
  maskedLabel: _propTypes.default.string,
  /**
   * @private
   * Boolean value indicating whether or not the column header is selectable.
   */
  isSelectable: _propTypes.default.bool,
  /**
   * @private
   * Boolean value indicating whether or not the cell should render as selected.
   */
  isSelected: _propTypes.default.bool
});
var _default = exports.default = cellShape;