"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _cellShape = _interopRequireDefault(require("./cellShape"));
var rowShape = _propTypes.default.shape({
  /**
   * An identifier to uniquely identify the row within the table.
   */
  id: _propTypes.default.string.isRequired,
  /**
   * Data to be displayed in the cells of the row. Cells will be rendered in the row in the order given.
   */
  cells: _propTypes.default.arrayOf(_cellShape.default),
  /**
   * A boolean indicating whether or not the row should render as selected.
   */
  isSelected: _propTypes.default.bool,
  /**
   * A string identifier used to describe the row contents. This value will be used to construct additional labels
   * for internal controls (e.g. row selection cells).
   */
  ariaLabel: _propTypes.default.string
});
var _default = exports.default = rowShape;