"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _rowShape = _interopRequireDefault(require("./rowShape"));
var _subsectionShape = _interopRequireDefault(require("./subsectionShape"));
var sectionShape = _propTypes.default.shape({
  /**
   * An identifier for the section. This identifier should be unique across the set of sections provided.
   */
  id: _propTypes.default.string.isRequired,
  /**
   * A boolean indicating whether or not the the section is collapsible.
   */
  isCollapsible: _propTypes.default.bool,
  /**
   * A boolean indicating whether or not the section is collapsed. If true, contents of the section will not be displayed.
   */
  isCollapsed: _propTypes.default.bool,
  /**
   * A text string to render within the section header.
   */
  text: _propTypes.default.string,
  /**
   * An array of row objects to be rendered within the section.
   */
  rows: _propTypes.default.arrayOf(_rowShape.default),
  /**
   * An array of subsections objects to be rendered within the section.
   */
  subsections: _propTypes.default.arrayOf(_subsectionShape.default)
});
var _default = exports.default = sectionShape;